unit main;

interface

uses
  config, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Sockets, udpSocket, notify, ComCtrls, ExtCtrls, Menus, StdCtrls, ToolWin;
Const
 // opcode types
 AC_MESSAGE = 0;
 AC_IDENT_REQUEST = 1;
 AC_IDENT_REPLY = 2;
 AC_PRIVATE_CHAT = 6;
 AC_ENUM_REPLY = 7;
 AC_CHATLINE = 3;
 AC_JOIN = 8;
 AC_QUIT = 4;
 AC_CONFIRMATION = 5;
 AC_ENUM_NET = 255;
 NAME_LENGTH = 30;
 DATA_LENGTH = 500;
 ACTION_LENGTH = NAME_LENGTH + DATA_LENGTH + 3;
type
  Taction = packed record
    opcode:byte;
    length:word;
    name :array[0..(NAME_LENGTH -1)] of char;
    data  :array[0..(DATA_LENGTH - 1)] of char;
  end;
  TForm1 = class(TForm)
    notify1: Tnotify;
    udpSocket1: TudpSocket;
    Sockets1: TSockets;
    ImageList1: TImageList;
    ListView1: TListView;
    Panel1: TPanel;
    PopupMenu1: TPopupMenu;
    Restore1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    Memo1: TMemo;
    Panel2: TPanel;
    Shape1: TShape;
    Label1: TLabel;
    Label2: TLabel;
    Shape2: TShape;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    procedure EnumPCs;
    procedure Ijoin;
    procedure AddPC(name,ip:string);
    procedure RemovePC(name:string);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Restore1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure udpSocket1Error(msg: String; num: Integer);
    procedure udpSocket1CloseSocket(sender: TObject);
    procedure udpSocket1Receive(sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure ToolButton1Click(Sender: TObject);
    procedure Shape1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Shape1DragDrop(Sender, Source: TObject; X, Y: Integer);
  protected
    procedure WM_Q(var msg:Tmessage); message WM_QUERYENDSESSION;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  First,Closin:boolean;
  MyPCstring:string;
  MyPCbuff : array[0..(name_length - 1)] of char;
  mssages:Tstringlist;
implementation

{$R *.DFM}
uses amessage,msgs;
procedure Tform1.WM_Q(var msg:Tmessage);
begin
msg.Result:=1;
closin:=true;
close;
end;
procedure Tform1.AddPC(name,ip:string);
var
j,i:integer;
z:Tlistitem;
p:boolean;
begin
p:=true;
j:=listview1.Items.Count;
for i:=0 to j-1 do begin
z:=listview1.Items[i];
if z.Caption=name then p:=false;
end;
if p = true then begin
z:=listview1.items.add;
z.ImageIndex:=0;
z.Caption:=name;
z.SubItems.Add(ip);
end;
end;

procedure Tform1.RemovePC(name:string);
var
j,i:integer;
z:Tlistitem;
begin
j:=listview1.Items.Count;
for i:=0 to j-1 do begin
z:=listview1.Items[i];
if z.Caption=name then begin
listview1.Items.Delete(i);
break;
end;
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
first:=true;
mssages:=TstringList.create;
mssages.LoadFromFile('messages.txt');
closin:=false;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if closin=true then action:=caFree else begin
Notify1.GoTsr;
action:=caNone;
end;
end;

procedure TForm1.FormActivate(Sender: TObject);
var i,k:integer;
begin
if first=true then begin
form2.readconfig;
edit1.Align:=alBottom;
notify1.CreateIcon;
udpsocket1.S_Open;
myPcString:=config1.myname;
k:=length(myPcString);
if k > 29 then k:=29;
fillchar(myPcBuff,30,0);
for i:=1 to k do myPcBuff[i-1]:=myPcString[i];
Ijoin;
EnumPCs;
if config1.systray then notify1.goTsr;
first:=false;
end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
//width:=435;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
notify1.restore;
closin:=true;
close;
end;

procedure TForm1.Restore1Click(Sender: TObject);
begin
notify1.restore;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
form2.showme;
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
closin:=true;
close;
end;

procedure TForm1.udpSocket1Error(msg: String; num: Integer);
begin
label3.caption:='winsock UDP error :'+msg+' '+inttostr(num);
end;

procedure TForm1.udpSocket1CloseSocket(sender: TObject);
begin
label3.caption:='UDP socket released';
end;

procedure TForm1.udpSocket1Receive(sender: TObject);
var
ac,ac2:Taction;
l2,l:integer;
hh:ThostAbout;
nameStr:string;
dataStr:string;
begin
l:=ACTION_LENGTH;
hh:=udpsocket1.ReadBuff(ac,l);
ac.name[NAME_LENGTH - 1]:=#0; // so nasty hackers won't dis-
                // cover buffer overflows.
ac.data[DATA_LENGTH - 1]:=#0; // same
nameStr:=strpas(ac.name);
dataStr:=strpas(ac.data);
case ac.opcode of

 AC_MESSAGE        : begin
                     mssages.Add('FROM : '+nameStr+#13#10+'--------'+#13#10+dataStr+#13#10+'---------'+#13#10#13#10);
                     beep; beep; beep;
                     notify1.restore;
                     showmessage('You have new mail from '+nameStr);

                     end;
 AC_IDENT_REQUEST  : begin
                     // not yet implemented
                     end;

 AC_JOIN           : begin
                     addpc(namestr,hh.IP_dotdot);
                     end;
 AC_IDENT_REPLY    : begin

                     // not yet implemented
                     end;

 AC_CHATLINE       : begin
                     memo1.lines.add('<'+nameStr+'> '+dataStr);
                     end;

 AC_QUIT           : begin
                     removepc(nameStr);
                     end;

 AC_CONFIRMATION   : begin

                     end;

 AC_ENUM_REPLY     : begin
                     addpc(nameStr,hh.IP_dotdot);
                     end;
 AC_ENUM_NET       : begin
                     ac2.opcode:=AC_ENUM_REPLY;
                     for l2:=0 to NAME_LENGTH - 1 do ac2.name[l2]:=myPCBuff[l2];
                     ac2.name[NAME_LENGTH - 1]:=#0;
                     ac2.length:=0;
                     udpsocket1.Location:=hh.IP_dotdot;
                     l2:=ACTION_LENGTH-1;
                     udpsocket1.SendBuff(ac2,l2);

                     end;
end;

end;

procedure TForm1.FormDestroy(Sender: TObject);
var
ac:Taction;
l2,l:integer;
begin

ac.opcode:=AC_QUIT;
ac.length:=0;
for l2:=0 to NAME_LENGTH - 1 do ac.name[l2]:=myPCBuff[l2];
ac.name[NAME_LENGTH - 1] := #0;
udpsocket1.Location:=config1.broadcast;
l:=ACTION_LENGTH - 1;
udpsocket1.SendBuff(ac,l);
mssages.SaveToFile('messages.txt');
mssages.free;

end;

procedure Tform1.EnumPCs;
var ac:Taction;
l,l2:integer;
begin
listview1.items.Clear;
for l2:=0 to NAME_LENGTH - 1 do ac.name[l2]:=myPCBuff[l2];
ac.name[NAME_LENGTH - 1] := #0;
udpsocket1.Location:=config1.broadcast;
ac.opcode:=AC_ENUM_NET;
ac.length:=0;
l:=ACTION_LENGTH - 1;
udpsocket1.SendBuff(ac,l);
//
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
var ac:Taction;
s:string;
l,l2:integer;
begin
if key = #13 then begin
for l2:=0 to NAME_LENGTH - 1 do ac.name[l2]:=myPCBuff[l2];
ac.name[NAME_LENGTH - 1] := #0;
ac.opcode:=AC_CHATLINE;
s:=edit1.text+'*';
ac.length:=length(s);
edit1.text:='';
if ac.length > data_LENGTH then ac.length:=data_LENGTH;
for l2:=1 to ac.length do ac.data[l2-1]:=s[l2];
ac.data[ac.length- 1]:=#0;
udpsocket1.Location:=config1.broadcast;
l:=ACTION_LENGTH-1;
udpsocket1.SendBuff(ac,l);
key:=#0;
end;
end;


procedure Tform1.Ijoin;
var ac:Taction;
l,l2:integer;
begin
for l2:=0 to NAME_LENGTH - 1 do ac.name[l2]:=myPCBuff[l2];
ac.name[NAME_LENGTH - 1] := #0;
udpsocket1.Location:=config1.broadcast;
ac.opcode:=AC_JOIN;
ac.length:=0;
l:=ACTION_LENGTH - 1;
udpsocket1.SendBuff(ac,l);
end;


procedure TForm1.ToolButton1Click(Sender: TObject);
begin
form3.Memo1.lines.assign(mssages);
form3.show;
end;

procedure TForm1.Shape1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
if (source is Tlistitem) then accept:=true;
end;

procedure TForm1.Shape1DragDrop(Sender, Source: TObject; X, Y: Integer);
var l:Tlistitem;
begin
if source = listview1 then begin
l:=listview1.Selected;
form4.SendMessageTo(l.caption,l.SubItems[0]);
end;
end;



end.
