unit notify;
{Unit notify version 2.00 created by Frank Dekervel
Delphi 3.00 version
Component: Tnotify.
included files: notify.pas + notify.dcr
e-mail Dekervel@iname.com
TNotify
    New features:
    -procedure Killapp(appname:string);
    -the property-setting procedures are protected now
kils appname by sending it a WM_CLOSE message
Modified on 10/10/1996.
-------------------------------------
REFERENCE
---------
PROPERTIES
          Hint:String the hint of the icon
          Icon:Ticon the icon to be showed
          Popupmenu: if not nil, this popupmenu will popup when
                     rightclicked on the icon.
                     TIP: add an non-implemented 'cancel' at the bottom
          RestoreOnDbl: when set to true, the application will restore when
                        doubleclicked on the icon.
          Name, Tag: default properties
EVENTS
          This events occur when a WM_KERVEL message is send to the HWND of the control
          It are notifyevents, but the sender parameter is always nil.
          OnIconClick, OnIconDblClick, OnIconMouseMove, OnIconRightClick, OnIconRightDoubleClick.
METHODS
          Killapp(appname:string):
                  closes appname by sending a WM_CLOSE message to it
          HideTaskBar(appname:string);
                  hides application titled appname
                  You can find the application name by minimizing it,
                  and looking at the taskbar.
                  E: The appname of delphi 3 is Delphi 3 and not Delphi 3 - project1
                  if appname is the caption of a form, the form will be hidden.
                  If the application name is the same as the form name, then hide the form
                  first, and after this the application.
          ShowTaskBar(appname:string);
                  Shows application or form.
          CreateIcon;
                  Creates the icon on the taskbar notification area
          DestroyIcon;
                  Destroys the blablablablabla
          UpdateIcon;
                  When changed a property, This procedure MUST be called
          GoTSR;
                  Creates the icon and hides the form and application from the taskbar
          Restore;
                  Shows the app and form on the taskbar.
          GoInvisible;
                  Makes your application invisible (only with CTRL-ALT-DEL you can see it)
                  This procedure destroys the icon on the TBN
          Hideapp;
                  Hides your application BUT NOT YOUR FORM
          Showapp;
                  Shows your application BUT BLABLABLABLABLA.

Mail me all the errors you find, If you want to distribute this, send me a mail.
Frank Dekervel, Dekervel@Iname.com
}
interface

uses
  ShellAPI, Windows, Messages, SysUtils, menus,Classes, Graphics, Controls, Forms, Dialogs;
const WM_KERVEL=WM_USER+11;
type
  Tnotify = class(TComponent)
  private
  Ficon:Ticon;
Fhint:string;
Fclick:Tnotifyevent;
FRclick:Tnotifyevent;
Fmove:Tnotifyevent;
FDBLclick:Tnotifyevent;
FRDblClick:Tnotifyevent;
Fpopupmenu:Tpopupmenu;
FnotifyIconData:TnotifyiconData;
Fwinhandle:HWND;
Fh1,Fh2:HWND;
Frestored:boolean;
Ftsr:boolean;
    { Private declarations }
  protected
    procedure setrestore(value:boolean);
    function getrestore:boolean;
    procedure WndProc(var msg:Tmessage);
    procedure sethint(value:string);
    procedure seticon(value:Ticon);
    procedure setpopup(value:Tpopupmenu);

    { Protected declarations }
  public
    procedure Killapp(appname:string);
    procedure GoInvisible;
    procedure HideTaskBar(appname:string);
    procedure ShowTaskBar(appname:string);
    procedure CreateIcon;
    procedure restore;
    procedure DestroyIcon;
    procedure UpdateIcon;
    procedure GoTSR;
    procedure hideapp;
    procedure showapp;
    destructor destroy; override;
    constructor create(Aowner:Tcomponent); override;
    { Public declarations }
  published
    property Hint:string read Fhint write Fhint;
    property Icon:Ticon read Ficon write Seticon;
    property Popupmenu:Tpopupmenu read Fpopupmenu write Fpopupmenu;
    property OnIconClick: TNotifyevent read Fclick write Fclick;
    property OnIconMouseMove: TNotifyevent read Fmove write Fmove;
    property OnIconRightClick:Tnotifyevent read FRclick write FRclick;
    property OnIconDblClick:Tnotifyevent read FdblClick write FdblClick;
    property OnIconRightDoubleClick:Tnotifyevent read FRDblClick write FRDblclick;
    property RestoreOnDBL:boolean read getrestore write setrestore;

    { Published declarations }
  end;

procedure Register;

implementation
procedure Tnotify.GoInvisible;
begin
showwindow(Fh1,sw_hide);
showwindow(Fh2,sw_hide);
Ftsr:=true;
end;
function Tnotify.getrestore:boolean;
begin
getrestore:=Frestored;
end;
procedure Tnotify.setrestore(value:boolean);
begin
Frestored:=value;
end;
procedure Tnotify.restore;
begin
if Ftsr = true then begin
showwindow(Fh1,sw_show);
showwindow(Fh2,sw_show);
Ftsr := false;
end;
end;
procedure Tnotify.GoTSR;
var FIappname,FIformname:string;
il:integer;
 q:array[0..255] of char;
begin
{FIappname:=appname;
FIformname:=formname;
for il:=1 to 254 do q[il-1]:=#0;
for il:=1 to 254 do q[il-1]:=FIappname[il];}
{Fh1:=findwindow(nil,q);}
{for il:=1 to 254 do q[il-1]:=#0;
for il:=1 to 254 do q[il-1]:=FIformname[il];
Fh2:=findwindow(nil,q);}

createIcon;
showwindow(Fh1,sw_hide);
showwindow(Fh2,sw_hide);
Ftsr:=true;
end;
procedure Tnotify.hideapp;
begin
showwindow(Fh1,sw_hide);
end;
procedure Tnotify.showapp;
begin
showwindow(Fh1,sw_show);

end;

constructor Tnotify.create(Aowner:Tcomponent);
begin
Ficon:=Ticon.create;
if (Aowner is Tform) then begin
fh2:=(Aowner as Tform).handle;
if (Aowner.Owner is Tapplication) then fh1:=(Aowner.Owner as Tapplication).handle;
end else showmessage('Creation error, place this on TFORM');
Fwinhandle:=AllocateHWND(WndProc);
inherited create(Aowner);
end;
destructor Tnotify.destroy;
begin
DestroyIcon;
Ficon.free;
DeallocateHWND(Fwinhandle);
inherited destroy;
end;
procedure Tnotify.WndPRoc(var msg:Tmessage);
var l:integer;
result:LRESULT;
pp:Tpoint;
begin
if msg.msg <> wm_kervel then Result := DefWindowProc(FWinHandle, Msg.msg, msg.wParam, msg.lParam);
if msg.msg = WM_KERVEL then begin
l:=msg.LParamLo;
if l = 512 then if assigned(fmove) then  Fmove(nil);
if l = 514 then if assigned (fclick) then Fclick(nil);
if l = 515 then begin
if (Frestored=true)  Then restore;
if assigned (FDBLclick) then FDBLclick(nil);
end;
if l = 516 then if assigned(FRclick) then FRclick(nil);
if l = 517 then if assigned(FRDBLclick) then FRDBLclick(nil);
if l = 516 then begin
getcursorpos(Pp);
if Fpopupmenu <> nil then Fpopupmenu.popup(pp.x,pp.y);
end;
end;
end;
procedure Tnotify.sethint(value:string);
begin
Fhint:=value;
end;

procedure Tnotify.seticon(value:TIcon);
begin
Ficon.assign(value);
end;

procedure Tnotify.setpopup(value:Tpopupmenu);
begin
Fpopupmenu:=value;
end;
procedure Tnotify.Killapp(appname:string);
var handle:HWND;
    r:array[0..255] of char;
    s:string;
    i:integer;
begin
s:=appname;
for i:=1 to 254 do r[i-1]:=#0;
for i:=1 to 254 do r[i-1]:=s[i];
handle:=findwindow(nil,r);
if handle > 0 then sendmessage(handle,WM_CLOSE,0,0);

end;

procedure Tnotify.HideTaskBar(appname:string);
var handle:HWND;
    r:array[0..255] of char;
    s:string;
    i:integer;
begin
s:=appname;
for i:=1 to 254 do r[i-1]:=#0;
for i:=1 to 254 do r[i-1]:=s[i];
handle:=findwindow(nil,r);
showwindow(handle,sw_hide);
end;

procedure Tnotify.ShowTaskBar(appname:string);
var handle:HWND;
    r:array[0..255] of char;
    s:string;
    i:integer;
begin
s:=appname;
for i:=1 to 254 do r[i-1]:=#0;
for i:=1 to 254 do r[i-1]:=s[i];
handle:=findwindow(nil,r);
showwindow(handle,sw_show);
end;

Procedure Tnotify.UpdateIcon;
var
i:integer;
Q:Array[0..63] of char;
begin
for i:=1 to 62 do Q[i-1]:=#0;
FnotifyIcondata.szTip:=#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0;
for i:=1 to 62 do FnotifyIconData.sztip[i-1]:=Fhint[i];
with FnotifyIconData do begin
cbsize:=sizeof(fnotifyIconData);
wnd:=Fwinhandle;
uID:=1;
uCallBackMessage:=WM_KERVEL;
uFlags:= NIF_ICON or NIF_TIP or NIF_Message;
hicon:=Ficon.handle;
{sztip:=Q;}
end;
shell_notifyIcon(NIM_MODIFY, @FnotifyIconData);
end;

procedure Tnotify.CreateIcon;
var
i:integer;
Q:Array[0..63] of char;
begin
for i:=1 to 63 do Q[i-1]:=#0;
for i:=1 to 62 do FnotifyIconData.sztip[i-1]:=Fhint[i];
with FnotifyIconData do begin
cbsize:=sizeof(fnotifyIconData);
wnd:=Fwinhandle;
uID:=1;
uCallBackMessage:=WM_KERVEL;
uFlags:= NIF_ICON or NIF_TIP or NIF_Message;
hicon:=Ficon.handle;
{sztip:=Q;}
end;
shell_notifyIcon(NIM_ADD, @FnotifyIconData);

end;

procedure Tnotify.DestroyIcon;
begin
shell_notifyIcon(NIM_DELETE, @FnotifyIconData);
end;
procedure Register;
begin
  RegisterComponents('system', [Tnotify]);
end;

end.
